diff --git a/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
index c2f64de27..30727fdd7 100644
--- a/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
@@ -1,11 +1,13 @@
 package net.minecraft.core.block.entity;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
+import com.mojang.nbt.CompoundTag;
 
 public class SeatBlockEntity
     extends BlockEntity
@@ -13,6 +15,9 @@ public class SeatBlockEntity
     private Entity passenger;
 
     public Block seat;
+    public SeatBlockEntity() {
+        this(null);
+    }
     public SeatBlockEntity(Block seat) {
         passenger = null;
         this.seat = seat;
@@ -132,4 +137,20 @@ public class SeatBlockEntity
     public void heldTick(World world, Entity holder) {
         tick();
     }
+
+    @Override
+    public void writeToNBT(CompoundTag compoundTag)
+    {
+        super.writeToNBT(compoundTag);
+        if (seat != null && seat != Blocks.SEAT) {
+            compoundTag.putInt("Block", seat.id);
+        }
+    }
+
+    @Override
+    public void readFromNBT(CompoundTag compoundTag)
+    {
+        super.readFromNBT(compoundTag);
+        seat = Block.getBlock(compoundTag.getIntegerOrDefault("Block", Blocks.SEAT.id));
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
index fbe867f72..375b508c8 100644
--- a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
@@ -143,8 +143,9 @@ public class MovingPistonBlockEntity extends BlockEntity
         worldObj.removeBlockTileEntity(x, y, z);
         invalidate();
         if(worldObj.getBlockId(x, y, z) == Blocks.PISTON_MOVING.id) {
-            worldObj.setBlockAndMetadata(x, y, z, movedId, movedData);
-            worldObj.notifyBlockChange(x, y, z, movedId);
+            // Don't combine these into setBlockAndMetadata, then onBlockPlacedByWorld can override the metadata
+            worldObj.setBlock(x, y, z, movedId);
+            worldObj.setBlockMetadata(x, y, z, movedData);
             if (movedEntity != null) {
                 BlockEntity oldEnt = worldObj.getBlockEntity(x, y, z);
                 if (oldEnt != null) {
@@ -156,6 +157,7 @@ public class MovingPistonBlockEntity extends BlockEntity
                 movedEntity.z = z;
                 worldObj.replaceBlockTileEntity(x, y, z, movedEntity);
             }
+            worldObj.notifyBlockChange(x, y, z, movedId);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java b/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
index 8d860ad50..f1adc8914 100644
--- a/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
@@ -18,6 +18,8 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class PistonBaseBlock extends Block
 {
@@ -43,7 +45,7 @@ public class PistonBaseBlock extends Block
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
     	Direction placementDirection = mob.getPlacementDirection(side).getOpposite();
         world.setBlockMetadataWithNotify(x, y, z, placementDirection.getId());
         if(!world.isClientSide)
@@ -290,7 +292,7 @@ public class PistonBaseBlock extends Block
         int z2 = z + direction.getOffsetZ();
         Block block = world.getBlock(x2, y2, z2);
         if (block == null) return true;
-        world.playSoundEffect(null, LevelListener.EVENT_BLOCK_BREAK, x2, y2, z2, world.getBlockId(x2, y2, z2));
+        world.playBlockEvent(null, LevelListener.EVENT_BLOCK_BREAK, x2, y2, z2, world.getBlockId(x2, y2, z2));
         block.dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x2, y2, z2, world.getBlockMetadata(x2, y2, z2), null, null);
         world.setBlockWithNotify(x2, y2, z2, 0);
         return true;
@@ -337,6 +339,9 @@ public class PistonBaseBlock extends Block
             int pushId = world.getBlockId(px, py, pz);
             int pushMeta = world.getBlockMetadata(px, py, pz);
             BlockEntity pushEntity = world.getBlockEntity(px, py, pz);
+            if (pushEntity instanceof MovingPistonBlockEntity) {
+                break;
+            }
             if(pushId == id && px == x && py == y && pz == z)
             {
                 createPistonHeadAt(world, xo, yo, zo, data, direction);
@@ -374,7 +379,7 @@ public class PistonBaseBlock extends Block
     }
     
     @Override
-    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
     	return MASK_DIRECTION; // For all faces piston blocks ig
     }
 }
diff --git a/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java b/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
index 98d010b18..45c6d8828 100644
--- a/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
+++ b/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
@@ -206,7 +206,7 @@ public class TreecapitatorHelper {
 				}	
 			}
 			if(particle) {
-				world.playSoundEffect(player, 2001, pos.x, pos.y, pos.z, block.id);
+				world.playBlockEvent(player, 2001, pos.x, pos.y, pos.z, block.id);
 			}
 			return true;
 		}
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index 09a8590b1..cfab3ca98 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -709,9 +709,9 @@ public abstract class Entity
         return true;
     }
 
-    protected void checkFallDamage(double d, boolean flag)
+    protected void checkFallDamage(double yd, boolean onGround)
     {
-        if (flag)
+        if (onGround)
         {
             if(fallDistance > 0.0F)
             {
@@ -719,12 +719,18 @@ public abstract class Entity
                 fallDistance = 0.0F;
             }
         }
-        else if (d < 0.0D)
+        else if (isFalling())
         {
-            fallDistance -= d;
+            fallDistance -= yd;
+        } else {
+            fallDistance = 0;
         }
     }
 
+    public boolean isFalling() {
+        return !onGround && !noPhysics && yd < 0 && vehicle == null;
+    }
+
     public AABB getBb()
     {
         return null;
diff --git a/src/main/java/net/minecraft/core/entity/ItemEntity.java b/src/main/java/net/minecraft/core/entity/ItemEntity.java
index 3fc5b2ac2..a176c3a65 100644
--- a/src/main/java/net/minecraft/core/entity/ItemEntity.java
+++ b/src/main/java/net/minecraft/core/entity/ItemEntity.java
@@ -39,7 +39,7 @@ public class ItemEntity extends Entity
     public ItemEntity(World world, double x, double y, double z, ItemStack itemstack) {
         super(world);
         age = 0;
-        health = 5;
+        health = 8;
         bobOffset = (float)(Math.random() * Math.PI * 2D);
         setSize(0.25F, 0.25F);
         heightOffset = bbHeight / 2.0F;
@@ -100,7 +100,7 @@ public class ItemEntity extends Entity
         yo = y;
         zo = z;
         yd -= 0.04D;
-        if(world.getBlockMaterial(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) == Material.lava)
+        if(isInLava())
         {
             yd = 0.2D;
             xd = (random.nextFloat() - random.nextFloat()) * 0.2F;
diff --git a/src/main/java/net/minecraft/core/entity/Mob.java b/src/main/java/net/minecraft/core/entity/Mob.java
index 3a1a5db8c..bac30820c 100644
--- a/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/src/main/java/net/minecraft/core/entity/Mob.java
@@ -1207,17 +1207,17 @@ public abstract class Mob extends Entity
         return prevSwingProgress + f1 * partialTick;
     }
 
-    public Vec3 getPosition(float partialTick)
+    public Vec3 getPosition(float partialTick, boolean headOffset)
     {
         if(partialTick == 1.0F)
         {
-            return Vec3.getTempVec3(x, y, z);
+            return Vec3.getTempVec3(x, y + (headOffset ? getHeadHeight() : 0), z);
         } else
         {
-            double d = xo + (x - xo) * (double)partialTick;
-            double d1 = yo + (y - yo) * (double)partialTick;
-            double d2 = zo + (z - zo) * (double)partialTick;
-            return Vec3.getTempVec3(d, d1, d2);
+            double x = MathHelper.lerp(xo, this.x, partialTick);
+            double y = MathHelper.lerp(yo, this.y, partialTick);
+            double z = MathHelper.lerp(zo, this.z, partialTick);
+            return Vec3.getTempVec3(x, y + (headOffset ? getHeadHeight() : 0), z);
         }
     }
 
@@ -1231,11 +1231,11 @@ public abstract class Mob extends Entity
     {
         if(partialTick == 1.0F)
         {
-            float f1 = MathHelper.cos(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
-            float f3 = MathHelper.sin(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
-            float f5 = -MathHelper.cos(-xRot * (MathHelper.PI / 180f));
-            float f7 = MathHelper.sin(-xRot * (MathHelper.PI / 180f));
-            return Vec3.getTempVec3(f3 * f5, f7, f1 * f5);
+            float z = MathHelper.cos(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
+            float x = MathHelper.sin(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
+            float xzLen = -MathHelper.cos(-xRot * (MathHelper.PI / 180f));
+            float y = MathHelper.sin(-xRot * (MathHelper.PI / 180f));
+            return Vec3.getTempVec3(x * xzLen, y, z * xzLen);
         }
         else
         {
@@ -1249,12 +1249,12 @@ public abstract class Mob extends Entity
         }
     }
 
-    public HitResult rayTrace(double d, float partialTick)
+    public HitResult rayTrace(double distance, float partialTick, boolean collideWithFluids, boolean ignoreNonColliderBlocks)
     {
-        Vec3 vec3 = getPosition(partialTick);
-        Vec3 vec31 = getViewVector(partialTick);
-        Vec3 vec32 = vec3.add(vec31.x * d, vec31.y * d, vec31.z * d);
-        return world.checkBlockCollisionBetweenPoints(vec3, vec32);
+        Vec3 head = getPosition(partialTick, true);
+        Vec3 viewDirection = getViewVector(partialTick);
+        Vec3 furthestPoint = head.add(viewDirection.x * distance, viewDirection.y * distance, viewDirection.z * distance);
+        return world.checkBlockCollisionBetweenPoints(head, furthestPoint, collideWithFluids, ignoreNonColliderBlocks);
     }
 
     public int getMaxSpawnedInChunk()
diff --git a/src/main/java/net/minecraft/core/entity/animal/SheepMob.java b/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
index e47b0eec9..c1b5a0639 100644
--- a/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
@@ -80,6 +80,22 @@ public class SheepMob extends Animal
         return false;
     }
 
+    public void onItemInteract(ItemStack itemStack) {
+        if (itemStack.getItem() instanceof ToolShearsItem && !getSheared()){
+            if(!world.isClientSide) {
+                setSheared(true);
+                int count = 2 + random.nextInt(3);
+                for (int j = 0; j < count; j++) {
+                    ItemEntity itemEntity = spawnAtLocation(new ItemStack(Blocks.WOOL.id, 1, getFleeceColor().blockMeta), 1.0F);
+                    itemEntity.yd += random.nextFloat() * 0.05F;
+                    itemEntity.xd += (random.nextFloat() - random.nextFloat()) * 0.1F;
+                    itemEntity.zd += (random.nextFloat() - random.nextFloat()) * 0.1F;
+                }
+            }
+            itemStack.damageItem(1, null);
+        }
+    }
+
     @Override
     public void addAdditionalSaveData(CompoundTag tag)
     {
@@ -155,7 +171,7 @@ public class SheepMob extends Animal
 			if (prevTimeSheepEating == 35) {
 				if(blockBelow == Blocks.GRASS || blockBelow == Blocks.GRASS_RETRO) {
 					if(!world.isClientSide) {
-						world.playSoundEffect(null, 2001, (int) x, (int) y - 1, (int) z, world.getBlockId((int) x, (int) y - 1, (int) z));
+						world.playBlockEvent(null, 2001, (int) x, (int) y - 1, (int) z, world.getBlockId((int) x, (int) y - 1, (int) z));
 						world.setBlockWithNotify(blockX, blockY - 1, blockZ, Blocks.DIRT.id);
 						setSheared(false);
 					}
diff --git a/src/main/java/net/minecraft/core/entity/monster/SkeletonMob.java b/src/main/java/net/minecraft/core/entity/monster/SkeletonMob.java
index a1981b76b..cb6960d9e 100644
--- a/src/main/java/net/minecraft/core/entity/monster/SkeletonMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/SkeletonMob.java
@@ -82,13 +82,13 @@ public class SkeletonMob extends Monster
             if(attackTime == 0)
             {
                 if(!world.isClientSide) {
-                    ArrowProjectile entityarrow = new ArrowProjectile(world, this, false, 0);
-                    entityarrow.y += 1.3999999761581421D;
-                    double d2 = (entity.y + (double) entity.getHeadHeight()) - 0.2D - entityarrow.y;
+                    ArrowProjectile arrow = new ArrowProjectile(world, this, false, 0);
+//                    arrow.y += 1.3999999761581421D;
+                    double d2 = (entity.y + (double) entity.getHeadHeight()) - 0.2D - arrow.y;
                     float f1 = MathHelper.sqrt(d * d + d1 * d1) * 0.2F;
                     world.playSoundAtEntity(null, this, "random.bow", 1.0F, 1.0F / (random.nextFloat() * 0.4F + 0.8F));
-                    entityarrow.setHeading(d, d2 + (double) f1, d1, 0.6F, 12F);
-                    world.entityJoinedWorld(entityarrow);
+                    arrow.setHeading(d, d2 + (double) f1, d1, 0.6F, 12F);
+                    world.entityJoinedWorld(arrow);
                 }
                 attackTime = 30;
             }
diff --git a/src/main/java/net/minecraft/core/entity/monster/SlimeMob.java b/src/main/java/net/minecraft/core/entity/monster/SlimeMob.java
index 57b604f42..9b655a930 100644
--- a/src/main/java/net/minecraft/core/entity/monster/SlimeMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/SlimeMob.java
@@ -92,8 +92,8 @@ public class SlimeMob extends Mob
     @Override
 	public void readAdditionalSaveData(CompoundTag tag)
     {
+        setSlimeSize(tag.getInteger("Size") + 1); sizeSet = true; // Loaded before the rest of data specifically to prevent it setting the size *after* loading the saved health
         super.readAdditionalSaveData(tag);
-        setSlimeSize(tag.getInteger("Size") + 1);
     }
 
     @Override
@@ -181,10 +181,10 @@ public class SlimeMob extends Mob
             {
                 float f = (((float)(j % 2) - 0.5F) * (float)size) / 4F;
                 float f1 = (((float)(j / 2) - 0.5F) * (float)size) / 4F;
-                SlimeMob entityslime = new SlimeMob(world, true);
-                entityslime.setSlimeSize(size / 2);
-                entityslime.moveTo(x + (double)f, y + 0.5D, z + (double)f1, random.nextFloat() * 360F, 0.0F);
-                world.entityJoinedWorld(entityslime);
+                SlimeMob slimeMob = new SlimeMob(world, true);
+                slimeMob.setSlimeSize(size / 2);
+                slimeMob.moveTo(x + (double)f, y + 0.5D, z + (double)f1, random.nextFloat() * 360F, 0.0F);
+                world.entityJoinedWorld(slimeMob);
             }
 
         }
diff --git a/src/main/java/net/minecraft/core/entity/player/Player.java b/src/main/java/net/minecraft/core/entity/player/Player.java
index cbec30952..2bdfb5881 100644
--- a/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -2,6 +2,7 @@ package net.minecraft.core.entity.player;
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.enums.Difficulty;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.Stat;
@@ -831,7 +832,7 @@ public abstract class Player extends Mob
     @Override
 	public float getHeadHeight()
     {
-        return 0.12F;
+        return 0;
     }
 
     protected void resetHeight()
@@ -973,6 +974,10 @@ public abstract class Player extends Mob
     {
     }
 
+    public void displayActivatorScreen(ActivatorBlockEntity blockEntity)
+    {
+    }
+
     public void displaySignEditorScreen(SignBlockEntity blockEntity)
     {
     }
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
index 2d7f1a860..ddb05f295 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
@@ -771,6 +771,7 @@ public class MinecartEntity extends Entity implements Container {
     @Override
     public void addAdditionalSaveData(CompoundTag tag) {
         tag.putInt("Type", type);
+        tag.putInt("TypeMeta", typeMeta);
         switch (type){
             case CHEST_CART:
                 ListTag nbttaglist = new ListTag();
@@ -795,6 +796,7 @@ public class MinecartEntity extends Entity implements Container {
     @Override
     public void readAdditionalSaveData(CompoundTag tag) {
         type = tag.getInteger("Type");
+        typeMeta = tag.getInteger("TypeMeta");
         switch (type){
             case CHEST_CART:
                 ListTag nbttaglist = tag.getList("Items");
diff --git a/src/main/java/net/minecraft/core/item/BoatItem.java b/src/main/java/net/minecraft/core/item/BoatItem.java
index 3dbe8f6b4..a90562476 100644
--- a/src/main/java/net/minecraft/core/item/BoatItem.java
+++ b/src/main/java/net/minecraft/core/item/BoatItem.java
@@ -6,14 +6,18 @@ package net.minecraft.core.item;
 //            World, MovingObjectPosition, EnumMovingObjectType, Block, 
 //            BoatEntity, ItemStack
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.entity.vehicle.BoatEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 
+import java.util.Random;
+
 public class BoatItem extends Item
 {
 
@@ -57,7 +61,7 @@ public class BoatItem extends Item
                 {
                     j--;
                 }
-                BoatEntity boat = new BoatEntity(world, (float)i + 0.5F, (float)j + 1.0F, (float)k + 0.5F);
+                BoatEntity boat = new BoatEntity(world, i + 0.5F, j + 1.0F, k + 0.5F);
                 boat.setRot(entityplayer.yRot - 90, 0);
                 world.entityJoinedWorld(boat);
             }
@@ -65,4 +69,14 @@ public class BoatItem extends Item
         }
         return itemstack;
     }
+
+    @Override
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        double x = blockX + offX + direction.getOffsetX();
+        double y = blockY + offY + direction.getOffsetY();
+        double z = blockZ + offZ + direction.getOffsetZ();
+        itemStack.consumeItem(null);
+        BoatEntity boat = new BoatEntity(world, x, y, z);
+        world.entityJoinedWorld(boat);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/item/BucketItem.java b/src/main/java/net/minecraft/core/item/BucketItem.java
index 5d92fb0fa..2dfb760fc 100644
--- a/src/main/java/net/minecraft/core/item/BucketItem.java
+++ b/src/main/java/net/minecraft/core/item/BucketItem.java
@@ -38,24 +38,8 @@ public class BucketItem extends Item
 
     @Override
 	public ItemStack onUseItem(ItemStack stack, World world, Player player) {
-		float f = 1.0F;
-		float f1 = player.xRotO + (player.xRot - player.xRotO) * f;
-		float f2 = player.yRotO + (player.yRot - player.yRotO) * f;
-		double posX = player.xo + (player.x - player.xo) * (double) f;
-		float yOff = player instanceof ServerPlayer ? player.getHeightOffset() : 0;
-		double posY = (player.yo + (player.y - player.yo)) + yOff;
-		double posZ = player.zo + (player.z - player.zo) * (double) f;
-		Vec3 vec3 = Vec3.getTempVec3(posX, posY, posZ);
-		float f3 = MathHelper.cos(-f2 * 0.01745329F - MathHelper.PI);
-		float f4 = MathHelper.sin(-f2 * 0.01745329F - MathHelper.PI);
-		float f5 = -MathHelper.cos(-f1 * 0.01745329F);
-		float f6 = MathHelper.sin(-f1 * 0.01745329F);
-		float f7 = f4 * f5;
-		float f8 = f6;
-		float f9 = f3 * f5;
 		double reachDistance = player.getGamemode().getBlockReachDistance();
-		Vec3 vec31 = vec3.add((double) f7 * reachDistance, (double) f8 * reachDistance, (double) f9 * reachDistance);
-		HitResult rayTraceResult = world.checkBlockCollisionBetweenPoints(vec3, vec31, idToPlace == 0);
+		HitResult rayTraceResult = player.rayTrace(reachDistance, 1f, idToPlace == 0, false);
 		
 		if(rayTraceResult == null || rayTraceResult.hitType != HitResult.HitType.TILE) {
 			return stack;
@@ -88,13 +72,13 @@ public class BucketItem extends Item
 		
 		if(world.isAirBlock(x, y, z) || !world.getBlockMaterial(x, y, z).isSolid()) {
 			if(world.dimension == Dimension.NETHER && idToPlace == Blocks.FLUID_WATER_FLOWING.id) {
-				world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, z + 0.5, y + 0.5, x + 0.5, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
+				world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, z + 0.5, y + 0.5, x + 0.5, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
 				for (int l = 0; l < 8; l++) {
 					world.spawnParticle("largesmoke", x + Math.random(), y + Math.random(), z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
 				}
 			} else {
 				if(idToPlace == Blocks.FLUID_WATER_FLOWING.id) {
-					world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5F, y + 0.5F, z + 0.5F, "liquid.splash", 0.5f, 1.0f);
+					world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, x + 0.5F, y + 0.5F, z + 0.5F, "liquid.splash", 0.5f, 1.0f);
 				}
 				player.swingItem();
 				Block block1 = world.getBlock(x, y, z);
diff --git a/src/main/java/net/minecraft/core/item/DyeItem.java b/src/main/java/net/minecraft/core/item/DyeItem.java
index b05a59dca..7dcca1e28 100644
--- a/src/main/java/net/minecraft/core/item/DyeItem.java
+++ b/src/main/java/net/minecraft/core/item/DyeItem.java
@@ -3,18 +3,23 @@ package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.entity.SignBlockEntity;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.SheepMob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.type.WorldTypes;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
 
 public class DyeItem extends Item
 {
@@ -33,7 +38,7 @@ public class DyeItem extends Item
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         if (world.getBlockId(blockX, blockY, blockZ) == Blocks.SIGN_POST_PLANKS_OAK.id || world.getBlockId(blockX, blockY, blockZ) == Blocks.SIGN_WALL_PLANKS_OAK.id)
         {
@@ -41,7 +46,7 @@ public class DyeItem extends Item
             if ((DyeColor.WHITE.itemMeta - itemstack.getMetadata()) != sign.getColor().id)
             {
                 sign.setColor(TextFormatting.get(DyeColor.WHITE.itemMeta - itemstack.getMetadata()));
-                if (entityplayer.getGamemode().consumeBlocks())
+                if (player == null || player.getGamemode().consumeBlocks())
                 {
                     itemstack.stackSize--;
                 }
@@ -54,7 +59,7 @@ public class DyeItem extends Item
             int id = world.getBlockId(blockX, blockY, blockZ);
             Block block = Block.blocksList[id];
             if (block instanceof IBonemealable){
-               if (((IBonemealable) block).onBonemealUsed(itemstack, entityplayer, world, blockX, blockY, blockZ, side, xPlaced, yPlaced)){
+               if (((IBonemealable) block).onBonemealUsed(itemstack, player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced)){
                    return true;
                }
             }
@@ -68,7 +73,7 @@ public class DyeItem extends Item
                     		grass = Blocks.GRASS_RETRO.id;
                     	}
                         world.setBlockWithNotify(blockX, blockY, blockZ, grass);
-                        if (entityplayer.getGamemode().consumeBlocks())
+                        if (player == null || player.getGamemode().consumeBlocks())
                         {
                         	itemstack.stackSize--;        	
                         }
@@ -83,7 +88,7 @@ public class DyeItem extends Item
                     if(Block.lightBlock[world.getBlockId(blockX, blockY + 1, blockZ)] <= 2) {
                         int grass = Blocks.GRASS_SCORCHED.id;
                         world.setBlockWithNotify(blockX, blockY, blockZ, grass);
-                        if (entityplayer.getGamemode().consumeBlocks())
+                        if (player == null || player.getGamemode().consumeBlocks())
                         {
                             itemstack.stackSize--;
                         }
@@ -96,7 +101,7 @@ public class DyeItem extends Item
             {
                 if(!world.isClientSide)
                 {
-                    if (entityplayer.getGamemode().consumeBlocks())
+                    if (player == null || player.getGamemode().consumeBlocks())
                     {
                     	itemstack.stackSize--;        	
                     }
@@ -154,6 +159,11 @@ label0:
         return false;
     }
 
+    @Override
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        onUseItemOnBlock(itemStack, null, world, blockX + direction.getOffsetX(), blockY + direction.getOffsetY(), blockZ + direction.getOffsetZ(), direction.getSide(), 0.5, 0.5);
+    }
+
     @Override
     public boolean useItemOnEntity(ItemStack itemstack, Mob mob, Player entityPlayer)
     {
diff --git a/src/main/java/net/minecraft/core/item/EggItem.java b/src/main/java/net/minecraft/core/item/EggItem.java
index 4c7771690..279118092 100644
--- a/src/main/java/net/minecraft/core/item/EggItem.java
+++ b/src/main/java/net/minecraft/core/item/EggItem.java
@@ -4,15 +4,16 @@ package net.minecraft.core.item;
 //            Item, ItemStack, World, EggProjectile,
 //            Player
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.entity.projectile.EggProjectile;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
 public class EggItem
-    extends Item
-    implements IDispensable
+    extends Item implements IDispensable
 {
 
     public EggItem(String name, String namespaceId, int id)
@@ -34,9 +35,17 @@ public class EggItem
     }
 
     @Override
-    public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random) {
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        EggProjectile eggProjectile = new EggProjectile(world, blockX + offX, blockY + offY, blockZ + offZ);
+        eggProjectile.setHeading(direction.getOffsetX() * 0.6, direction.getOffsetY() == 0 ? 0.1 : direction.getOffsetY() * 0.6, direction.getOffsetZ() * 0.6f, 1.1F, 6F);
+        world.entityJoinedWorld(eggProjectile);
+        itemStack.stackSize -= 1;
+    }
+
+    @Override
+    public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int yOffset, int zOffset, Random random) {
         EggProjectile eggProjectile = new EggProjectile(world, x, y, z);
-        eggProjectile.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+        eggProjectile.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
         world.entityJoinedWorld(eggProjectile);
     }
 }
